//Shard-Gun v2.0 --By takato14.

/////////////
//--SOUND--//
/////////////
datablock AudioProfile(ShardGunFireSound)
{
	filename = "./ShardGunfire.wav";
	description = AudioDefault3d;
	preload = true;
};

datablock AudioProfile(ChidoriHitSound)
{
	filename = "./ChidoriStrikeSound.wav";
	description = AudioClosest3d;
	preload = true;
};

//datablock AudioProfile(ShardGunMountSound)
//{
//	filename = "./ShardGunMount.wav";
//	description = AudioClosest3D;
//	preload = true;
//};

//////////////////////////////
//--PARTICLES AND EMITTERS--//
//////////////////////////////

datablock ParticleData(ShardGunTrailParticle)
{
	dragCoefficient      = 3.5;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.2;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 760;
	textureName          = "./shine3";
	spinSpeed		= 100.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.8 0.5 0.0 0.8";
	colors[1]     = "0.3 0.5 0.1 0.5";
   colors[2]     = "0.0 0.4 0.6 0.3";
   colors[3]     = "0.0 0.2 0.8 0.2";

	sizes[0]      = 2.75;
	sizes[1]      = 1.12;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ShardGunTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShardGunTrailParticle";

   uiName = "Shard-Gun Trail";
};

//If the Chidori datablocks didn't load, here's an extra copy

datablock ParticleData(ChidoriSparkParticle)
{
	dragCoefficent = 1.0;
	gravityCoefficient = 0.3;
	inheritedVelFactor = 1.0;
	constantAcceleration = 0.1;
	lifetimeMS = 300;
	lifetimeVarianceMS = 100;
	textureName = "./Lightning";
	spinSpeed = 100;
	spinRandomMin = 10;
	spinRandomMax = 1000;
	colors[0] = "0.2 0.4 1.0 0.9";
	colors[1] = "0.1 0.3 1.0 1.0";
	colors[2] = "0.0 0.2 9.0 0.3";
	sizes[0] = 0.89;
	sizes[1] = 0.49;
	sizes[2] = 0.23;
	times[0] = 1.0;
	times[1] = 2.1;
	times[2] = 3.2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriSparkEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 1;
	ejectionVelocity = 3;
	velocityVariance = 2;
	ejectionOffset = 0.1;
	thetaMin = 45;
	thetaMax = 86;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ChidoriSparkParticle";

	uiName = "Chidori Spark";
};

datablock ParticleData(ChidoriExplosionParticle)
{
	dragCoefficent = 0.0;
	gravityCoefficient = -0.35;
	inheritedVelFactor = 1.0;
	constantAcceleration = 0.6;
	lifetimeMS = 300;
	lifetimeVarianceMS = 30;
	textureName = "./Lightning";
	spinSpeed = 100;
	spinRandomMin = 10;
	spinRandomMax = 1000;
	colors[0] = "0.2 0.6 1.0 1.0";
	colors[1] = "0.1 0.4 1.0 1.0";
	colors[2] = "0.2 0.2 1.0 0.1";
	sizes[0] = 0.69;
	sizes[1] = 0.58;
	sizes[2] = 0.5;
	times[0] = 1.0;
	times[1] = 2.1;
	times[2] = 3.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriExplosionEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 1;
	ejectionVelocity = 2;
	velocityVariance = 1;
	ejectionOffset = 1.2;
	thetaMin = 86;
	thetaMax = 97;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ChidoriExplosionParticle";

	uiName = "Chidori Explosion";
};

datablock ParticleData(ChidoriTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 805;
	textureName          = "./shine2";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.2 0.4";
	colors[1]     = "1.0 0.2 1.0 0.5";
   colors[2]     = "0.20 1.0 0.20 0.3";
   colors[3]     = "0.4 0.7 1.0 0.5";

	sizes[0]      = 0.75;
	sizes[1]      = 1.12;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ChidoriTrailParticle";

   uiName = "Chidori Trail";
};

/////////////////
//--EXPLOSION--//
/////////////////

datablock DebrisData(TDGDebris)
{
   emitters = "ChidoriTrailEmitter";

	lifetime = 0.1;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0; 
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 0;
};

datablock ExplosionData(TDGExplosion)
{
   //explosionShape = "";
   //explosionShape = "./explosionSphere1.dts";
	soundProfile = ChidoriHitSound;

   particleEmitter = ChidoriExplosionEmitter;
   particleDensity = 100;
   particleRadius = 1;

   emitter[0] = ChidoriSparkEmitter;
   emitter[1] = ChidoriTrailEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

  shakeCamera = true;
   camShakeFreq = "30.0 20.0 25.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 5.0;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.0 0.6 0.6 0.9";
   lightEndColor = "0.0 0.1 1.0 1";

   debris = TDGDebris;
   debrisNum = 30;
   debrisNumVariance = 10;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 100;
   debrisVelocityVariance = 50;

   damageRadius = 1;
   radiusDamage = 1000;

   uiname = "";
};

//////////////////
//--PROJECTILE--//
//////////////////

AddDamageType("Shardgun",   '<bitmap:add-ons/Weapon_Shardgun/CI_Shardgun> %1',    '%2 <bitmap:add-ons/Weapon_Shardgun/CI_Shardgun> %1',0.2,1);
datablock ProjectileData(ShardgunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 2;
   directDamageType    = $DamageType::Shardgun;
   radiusDamageType    = $DamageType::Shardgun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 100;
   brickExplosionMaxVolume = 100;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 200;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 10;
   verticalImpulse	  = 10;
   //explosion           = "";
   bounceExplosion     = TDGExplosion;
   particleEmitter     = ShardGunTrailEmitter;

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 32;
   lifetime            = 250;
   fadeDelay           = 400;
   bounceElasticity    = 0;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5;
   lightColor  = "0 0.5 0.5";
};

////////////
//--ITEM--//
////////////
datablock ItemData(ShardgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ShardGun_NH.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Shard-Gun";
	iconName = "./UI_ShardGun_v2";
	//doColorShift = false;
	//colorShiftColor = "0.15 0.25 0.15 1.000";

	 // Dynamic properties defined by the scripts
	image = ShardgunImage;
	canDrop = true;
};

////////////////////
//--WEAPON IMAGE--//
////////////////////
datablock ShapeBaseImageData(ShardgunImage)
{
   // Basic Item properties
   shapeFile = "./ShardGun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ShardgunProjectile;
   projectileType = Projectile;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1600;

   //doColorShift = false;
   //colorShiftColor = ShardgunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.7;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	stateSequence[0]		= "mount";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recoil";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "BOOM";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	//stateEmitter[2]					= "";
	//stateEmitterTime[2]				= 0.05;
	//stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= ShardGunFireSound;
	//stateEjectShell[2]       = false;

	stateName[3] = "Recoil";
	//stateEmitter[3]					= "";
	//stateEmitterTime[3]				= 0.5;
	//stateEmitterNode[3]				= "muzzleNode";
	stateSequence[3]		= "recoil";
	stateTimeoutValue[3]            = 0.65;
	stateTransitionOnTimeout[3]     = "wait";

	stateName[5]			= "wait";
	stateTimeoutValue[5]		= 0.5;
	stateWaitForTimeout[5]		= true;
	stateTransitionOnTimeout[5]	= "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

/////////////////////////
//--SPECIAL FUNCTIONS--//
/////////////////////////
function ShardgunImage::onMount(%this,%obj,%slot)
{
	parent::onMount(%this, %obj, %slot);
	%obj.hideNode("Rhand");
}

function ShardgunImage::onUnMount(%this,%obj,%slot)
{
	parent::onUnMount(%this, %obj, %slot);
	%obj.unHideNode("Rhand");
}
	
function ShardgunImage::onFire(%this,%obj,%slot)
{
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-18")));

	%projectile = %this.projectile;
	%spread = 0.0095;
	%shellcount = 75;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


